/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison interface for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

#ifndef YY_YY_PARSER_H_INCLUDED
# define YY_YY_PARSER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif
/* "%code requires" blocks.  */
#line 1 "../src/parser.y" /* yacc.c:1909  */

/*
 * boxes - Command line filter to draw/remove ASCII boxes around text
 * Copyright (c) 1999-2021 Thomas Jensen and the boxes contributors
 *
 * This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public
 * License, version 3, as published by the Free Software Foundation.
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 * You should have received a copy of the GNU General Public License along with this program.
 * If not, see <https://www.gnu.org/licenses/>.
 *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

/*
 * Yacc parser for boxes configuration files
 */

#include "config.h"
#include "boxes.h"


/** all the arguments which we pass to the bison parser */
typedef struct {
    /** bison will store the parsed designs here, also allocating memory as required */
    design_t *designs;

    /** the size of `*designs` */
    size_t num_designs;

    /** index into `*designs` */
    int design_idx;

    /** Box designs already parsed from child config files, if any. Else NULL */
    design_t *child_configs;

    /** the size of `*child_configs` */
    size_t num_child_configs;

    /** the path to the config file we are parsing */
    char *config_file;

    int num_mandatory;

    int time_for_se_check;

    /** number of user-specified shapes */
    int num_shapespec;

    /** used to limit "skipping" msgs */
    int skipping;

    /** true if we're skipping designs, but no error */
    int speeding;

    /** names of config files specified via "parent" */
    char **parent_configs;

    /** number of parent config files (size of parent_configs array) */
    size_t num_parent_configs;

    /** the flex scanner state, which is explicitly passed to reentrant bison */
    void *lexer_state;
} pass_to_bison;


#line 113 "parser.h" /* yacc.c:1909  */

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YPARENT = 258,
    YSHAPES = 259,
    YELASTIC = 260,
    YPADDING = 261,
    YSAMPLE = 262,
    YENDSAMPLE = 263,
    YBOX = 264,
    YEND = 265,
    YUNREC = 266,
    YREPLACE = 267,
    YREVERSE = 268,
    YTO = 269,
    YWITH = 270,
    YCHGDEL = 271,
    YTAGS = 272,
    KEYWORD = 273,
    WORD = 274,
    STRING = 275,
    FILENAME = 276,
    SHAPE = 277,
    YNUMBER = 278,
    YRXPFLAG = 279,
    YDELIMSPEC = 280
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 115 "../src/parser.y" /* yacc.c:1909  */

    char *s;
    char c;
    shape_t shape;
    sentry_t sentry;
    int num;

#line 159 "parser.h" /* yacc.c:1909  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif



int yyparse (pass_to_bison *bison_args);

#endif /* !YY_YY_PARSER_H_INCLUDED  */
